// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package servis

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ServisClient is the client API for Servis service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ServisClient interface {
	// Pull a servis given a name
	Pull(ctx context.Context, in *PullRequest, opts ...grpc.CallOption) (*PullResponse, error)
	// Push changes or a new servis
	Push(ctx context.Context, in *PushRequest, opts ...grpc.CallOption) (*PushResponse, error)
	// Check and lint your servis against the linter and breaking changes
	Check(ctx context.Context, in *CheckRequest, opts ...grpc.CallOption) (*CheckResponse, error)
}

type servisClient struct {
	cc grpc.ClientConnInterface
}

func NewServisClient(cc grpc.ClientConnInterface) ServisClient {
	return &servisClient{cc}
}

func (c *servisClient) Pull(ctx context.Context, in *PullRequest, opts ...grpc.CallOption) (*PullResponse, error) {
	out := new(PullResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.servis.Servis/Pull", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *servisClient) Push(ctx context.Context, in *PushRequest, opts ...grpc.CallOption) (*PushResponse, error) {
	out := new(PushResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.servis.Servis/Push", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *servisClient) Check(ctx context.Context, in *CheckRequest, opts ...grpc.CallOption) (*CheckResponse, error) {
	out := new(CheckResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.servis.Servis/Check", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ServisServer is the server API for Servis service.
// All implementations must embed UnimplementedServisServer
// for forward compatibility
type ServisServer interface {
	// Pull a servis given a name
	Pull(context.Context, *PullRequest) (*PullResponse, error)
	// Push changes or a new servis
	Push(context.Context, *PushRequest) (*PushResponse, error)
	// Check and lint your servis against the linter and breaking changes
	Check(context.Context, *CheckRequest) (*CheckResponse, error)
	mustEmbedUnimplementedServisServer()
}

// UnimplementedServisServer must be embedded to have forward compatible implementations.
type UnimplementedServisServer struct {
}

func (UnimplementedServisServer) Pull(context.Context, *PullRequest) (*PullResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Pull not implemented")
}
func (UnimplementedServisServer) Push(context.Context, *PushRequest) (*PushResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Push not implemented")
}
func (UnimplementedServisServer) Check(context.Context, *CheckRequest) (*CheckResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Check not implemented")
}
func (UnimplementedServisServer) mustEmbedUnimplementedServisServer() {}

// UnsafeServisServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ServisServer will
// result in compilation errors.
type UnsafeServisServer interface {
	mustEmbedUnimplementedServisServer()
}

func RegisterServisServer(s grpc.ServiceRegistrar, srv ServisServer) {
	s.RegisterService(&Servis_ServiceDesc, srv)
}

func _Servis_Pull_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PullRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServisServer).Pull(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.servis.Servis/Pull",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServisServer).Pull(ctx, req.(*PullRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Servis_Push_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PushRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServisServer).Push(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.servis.Servis/Push",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServisServer).Push(ctx, req.(*PushRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Servis_Check_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CheckRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServisServer).Check(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.servis.Servis/Check",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServisServer).Check(ctx, req.(*CheckRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Servis_ServiceDesc is the grpc.ServiceDesc for Servis service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Servis_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.sip.servis.Servis",
	HandlerType: (*ServisServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Pull",
			Handler:    _Servis_Pull_Handler,
		},
		{
			MethodName: "Push",
			Handler:    _Servis_Push_Handler,
		},
		{
			MethodName: "Check",
			Handler:    _Servis_Check_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/sip/servis/servis.proto",
}
